10 CLS
11 CLEAR
12 ON ERROR GOTO 25000
13 GOSUB 26000
14 DEFDBL A-H,M-Z
15 KEY OFF
20 COLOR 15,1:PRINT SPACE$(160);:PRINT SPACE$(160):LOCATE 1,1
30 PRINT "                        AC NETWORK ANALYSIS     "
33 PRINT "                          PUBLIC DOMAIN   "
40 PRINT "     THIS PROGRAM ANALYZES ACTIVE AND PASSIVE CIRCUITS UP TO 25 NODES."
42 PRINT "                              "
50 COLOR 7,0:PRINT
55 AMAXDB=-999
60 INPUT "INFORMATION (Y/N) ";INF$
70 PRINT
80 IF (INF$="Y") OR (INF$="y") THEN GOSUB 6200
90 INPUT "PRINTER UNAVAILABLE(0) OR AVAILABLE(1) ";PAV
100 INPUT "IF DATA IS CONTAINED IN A FILE, PRINT FILENAME ELSE <RET>  ";F$
105 IF PAV=1 THEN LPRINT:LPRINT:LPRINT:LPRINT:LPRINT "                      AC NETWORK ANALYSIS"
106 IF PAV=1 THEN LPRINT "THIS PROGRAM ANALYZES ACTIVE AND PASSIVE CIRCUITS UP TO 25 NODES":LPRINT
110 IF PAV =1 THEN LPRINT "IF DATA IS CONTAINED IN A FILE, PRING FILENAME ELSE <RET>  ";F$
150 REM IF F$="" THEN LINE INPUT "TYPE TITLE OR <RET> ";TITLE$
160 REM IF (PAV = 1) AND (F$="") THEN LPRINT:LPRINT TITLE$:LPRINT
212 IF (F$="") THEN G$="DEFAULT"
220 PRINT:IF PAV=1 THEN  LPRINT
224 PRINT "(0) EXACT ANALYSIS"
226 PRINT "(1) MONTE CARLO ANALYSIS"
228 INPUT MONTE
230 IF PAV = 1 THEN LPRINT "(0) EXACT ANALYSIS":LPRINT "(1) MONTE CARLO ANALYSIS":LPRINT MONTE
232 IF MONTE = 0 THEN GOTO 280
234 PRINT:IF PAV=1 THEN LPRINT
236 INPUT "TYPE RESISTOR TOLERANCE IN PERCENT ";RT
238 INPUT "TYPE CAPACITOR TOLERANCE IN PERCENT ";CT
240 INPUT "TYPE INDUCTOR TOLERANCE IN PERCENT ";LT
242 IF PAV =1 THEN LPRINT "TYPE RESISTOR TOLERANCE IN PERCENT ";RT
244 IF PAV = 1 THEN LPRINT "TYPE CAPACITOR TOLERANCE IN PERCENT ";CT
246 IF PAV = 1 THEN LPRINT "TYPE INDUCTOR TOLERANCE IN PERCENT ";LT
248 PRINT:IF PAV = 1 THEN LPRINT
250 INPUT "TYPE NUMBER OF SIMULATIONS ";MC
252 IF PAV = 1 THEN LPRINT "TYPE NUMBER OF SIMULATIONS ";MC
253 MC=MC-1
254 RANDOMIZE TIMER
255 MONTE=MC            'mc is number of simulations - 1
280 IF PAV = 1 THEN LPRINT
290 PRINT
300 PRINT "COMPONENTS TYPE ARE R=RESISTOR, C=CAPACITOR, L=INDUCTOR"
310 PRINT "  O=AMPLIFIER, F=FETS, B=BIPOLAR TRANSISTORS, <RET>=QUIT"
320 PRINT
330 IF PAV=1 THEN LPRINT  "COMPONENTS TYPE ARE R=RESISTOR, C=CAPACITOR, L=INDUCTOR"
340 IF PAV=1 THEN LPRINT "  O=AMPLIFIER, F=FETS, B=BIPOLAR TRANSISTORS, <RET>=QUIT"
350 IF PAV=1 THEN LPRINT
490 IF G$="" THEN GOTO 1000
500  FOR I=1 TO LEN(G$)                         ' Check for extension
510  IF MID$(G$,I,1)="." THEN J=I
520  NEXT I
530  IF J<>0 THEN G$=MID$(G$,1,J-1)             ' Add .NET if missing
540  G$=G$+".net"
550 J=0
1000 ' NETWORK - An AC electronic circuit simulator program
1100 OPEN "DATA" FOR OUTPUT AS #3
1110 PRINT #3,1
1120 CLOSE #3
1130 KILL"DATA*.*
1140 IF MONTE = MC THEN PRINT
1150 IF MONTE > 0 THEN E$=STR$(MC+1) ELSE E$=""     'build filename to save
1152 IF MONTE = 0 THEN DAT$="DATA" ELSE DAT$="DATA."+MID$(E$,2)
1154 OPEN DAT$ FOR OUTPUT AS #3
1160 I=0:J=0:K=0:N=0:I1=0
1190 IF MONTE=MC THEN PRINT
1200 Y=40                               ' Allocate memory for circuit
1220 'Note: If you have less than 64K in your system, you must decrease Y
1240 DIM A(25,25),B(25,25),P(25,25),Q(25,25),B1(25,25),Q1(25,25)
1250 DIM C1(201),D1(201),E1(201),ORIG$(25),PREV$(25),ORIGD1(201),NOWD1(201)
1300 N=0:PI=3.141592:LGTEN=8.685889	' Initialize constants	
1340 REM
1360 IF F$="" THEN GOTO 1500
1380 FOR I=1 TO LEN(F$)                         ' Check for extension
1400 IF MID$(F$,I,1)="." THEN J=I
1420 NEXT I
1440 IF J<>0 THEN F$=MID$(F$,1,J-1)             ' Add .NET if missing
1460 F$=F$+".net"
1500 IF F$<>"" THEN OPEN F$ FOR INPUT AS #1
1502 IF G$<>"" THEN OPEN G$ FOR OUTPUT AS #2
1504 IF G$<>"" THEN PRINT #2,";"+TITLE$
1505 IF F$="" THEN GOTO 1545
1510 IF MONTE=MC THEN PRINT
1515 IF  (PAV=1) AND (MC=MONTE) THEN LPRINT
1520 IF F$<>"" THEN LINE INPUT #1,Z$
1522 IF F$<>"" THEN D$=LEFT$(Z$,1)
1524 IF (D$<>";") AND (F$<>"")  THEN PRINT:INPUT "INCOMPATIBLE FILE TYPE, PRESS <RET> TO CONTINUE ";T1$:GOTO 10
1525 IF (D$=";") AND (F$<>"") THEN GOTO 1550
1530 '
1531 '
1532 '************* Main Loop for Input of Circuit Description *************
1533 '
1540 IF F$="" THEN GOTO 1545
1541 IF  EOF(1) THEN GOTO 2220
1545 IF F$ <>"" THEN INPUT #1,Z$
1550 IF (F$<>"") AND (MONTE=0) THEN PRINT Z$
1553 IF F$="" THEN INPUT "ENTER COMPONENT TYPE ";Z$
1554 IF (PAV=1) AND (F$="") THEN LPRINT "ENTER COMPONENT TYPE ";Z$
1555 IF (PAV=1) AND (F$<>"") AND (MONTE=0) THEN LPRINT Z$
1556 IF (G$<>"") AND (F$="") THEN PRINT #2,Z$
1557 IF (Z$="") THEN GOTO 2220
1558 IF F$="" THEN PRINT "ENTER NODES,VALUE    ";
1559 IF (PAV=1) AND (F$="") THEN LPRINT "ENTER NODES,VALUE    ";
1560 E$=Z$:Z$=LEFT$(Z$,1)
1570 IF Z$=";" THEN GOTO 1540              'Comment for Description of Circuit
1580 IF Z$="R" OR Z$="r" THEN 1860         'Resistors
1600 IF Z$="C" OR Z$="c" THEN 1900         'Capacitors
1620 IF Z$="L" OR Z$="l" THEN 1960         'Inductors
1640 IF Z$="O" OR Z$="o" THEN 2140:NOP=1   'Amplifiers
1660 IF Z$="F" OR Z$="f" THEN 2020:NOP=1   'Fets
1680 IF Z$="B" OR Z$="b" THEN 2060:NOP=1   'Bipolar Transistors
1720 IF F$<>"" THEN CLOSE #1                              'Not Valid Component
1730 BEEP:BEEP
1740 PRINT
1760 PRINT"Bad component type":PRINT Z$
1800 PRINT
1840 END
1850 '
1851 '
1852 ' ************** Enter Component Parameters into Matrix ****************
1853 '
1860 IF F$<>"" THEN INPUT #1,I,J,V ELSE INPUT I,J,V             'resistor
1861 IF G$<>"" THEN PRINT #2,I,J,V
1862 UPPERB = V*(1+RT/100):LOWERB = V*(1-RT/100)
1865 V = ((UPPERB - LOWERB )*RND + LOWERB)
1867 IF (F$<>"") AND (MONTE=0) THEN PRINT CSNG(I);",";CSNG(J);",";CSNG(V)
1870 IF (PAV=1) AND (MONTE=0) THEN LPRINT CSNG(I);",";CSNG(J);",";CSNG(V)
1880 V=1/V:GOSUB 3900:GOTO 1540
1900 IF F$<>"" THEN INPUT #1,I,J,V ELSE INPUT I,J,V              'capacitor
1901 IF G$<>"" THEN PRINT #2,I,J,V
1902 UPPERB = V*(1+CT/100):LOWERB = V*(1-CT/100)
1905 V = ((UPPERB - LOWERB )*RND + LOWERB)
1907 IF (F$<>"") AND (MONTE=0) THEN PRINT CSNG(I);",";CSNG(J);",";CSNG(V)
1910 IF (PAV=1) AND (MONTE=0) THEN LPRINT CSNG(I);",";CSNG(J);",";CSNG(V)
1920 REM V=V/1000000!
1940 GOSUB 4120:GOTO 1540
1960 IF F$<>"" THEN INPUT #1,I,J,V ELSE INPUT I,J,V        ' inductor
1961 IF G$<>"" THEN PRINT #2,I,J,V
1962 UPPERB = V*(1+LT/100):LOWERB = V*(1-LT/100)
1964 V = ((UPPERB - LOWERB )*RND + LOWERB)
1966 IF (F$<>"") AND (MONTE=0) THEN PRINT CSNG(I);",";CSNG(J);",";CSNG(V)
1970 IF (PAV=1) AND (MONTE=0) THEN LPRINT CSNG(I);",";CSNG(J);",";CSNG(V)
1980 V=-1/V
2000 GOSUB 4260:GOTO 1540
2020 IF F$<>"" THEN INPUT #1,K,J,I,V ELSE INPUT K,J,I,V                'fet
2021 IF (F$<>"") AND (MONTE=0) THEN PRINT CSNG(K);",";CSNG(J);",";CSNG(I);",";CSNG(V)
2022 IF G$<>"" THEN PRINT #2,K,J,I,V
2023 IF (PAV=1) AND (MONTE=0) THEN LPRINT CSNG(K);",";CSNG(J);",";CSNG(I);",";CSNG(V)
2040 L=J:GOTO 2200
2060 IF F$<>"" THEN INPUT #1,K,J,I,B1,V ELSE INPUT K,J,I,B1,V   'NPN  transistorlist 30200-
2061 IF (F$<>"") AND (MONTE=0) THEN PRINT CSNG(K);",";CSNG(J);",";CSNG(I);",";CSNG(B1);",";CSNG(V)
2062 IF G$<>"" THEN PRINT #2,K,J,I,B1,V
2063 IF (PAV = 1) AND (MONTE=0) THEN LPRINT CSNG(K);",";CSNG(J);",";CSNG(I);",";CSNG(B1);",";CSNG(V)
2080 L=I:I=K:V=1/V:GOSUB 3900
2100 I=L:L=J:GOTO 2180
2120							' op amp
2140 IF F$<>"" THEN INPUT #1,K,L,J,I,B1,V ELSE INPUT K,L,J,I,B1,V  'in+,-:out+,-:,gain,ohms
2141 IF (F$<>"") AND (MONTE=0) THEN PRINT CSNG(K);",";CSNG(L);",";CSNG(J);",";CSNG(I);",";CSNG(B1);",";CSNG(V)
2142 IF G$<>"" THEN PRINT #2,K,L,J,I,B1,V
2143 IF (PAV=1) AND (MONTE=0)  THEN LPRINT CSNG(K);",";CSNG(L);",";CSNG(J);",";CSNG(I);",";CSNG(B1);",";CSNG(V)
2160 V=1/V:GOSUB 3900
2180 V=B1*V
2200 GOSUB 4400:GOTO 1540
2220 GOSUB 32200                       'SAVE ORIGINAL COMPONENT VALUES
2221 GOSUB 30000                      'see if modification is requested
2225 E=1:F=N                                            'end read io
2230 IF (PAV=1) AND (MONTE=MC) THEN LPRINT
2240 IF F$<>"" THEN CLOSE #1
2245 IF G$<>"" THEN CLOSE #2
2300 FOR I=0 TO N
2320 FOR J=0 TO N
2340 P(I,J)=A(I,J)
2360 Q1(I,J)=B1(I,J)
2380 Q(I,J)=B(I,J)
2400 NEXT J:NEXT I
3000 IF MONTE=MC THEN PRINT
3010 IF (MONTE >=1 ) AND (H<>0) THEN GOTO 3350
3020 PRINT "Circuit has ";N;"nodes"
3040 PRINT "Node";E;" = INPUT;   Node";F;" = OUTPUT"
3050 IF PAV=1 THEN LPRINT:LPRINT "Circuit has ";N;"nodes"
3055 IF PAV=1 THEN LPRINT "Node";E;" = INPUT;   Node";F;" = OUTPUT":LPRINT
3060 IF MONTE=MC THEN PRINT
3070 IF CHO = 10 THEN GOTO 3340
3200 ' entry point for new freq range
3225 REM INPUT "Enter file for data save [CR for no-save]: ",DATFILE$
3226 REM IF DATFILE$<>"" THEN OPEN DATFILE$ FOR OUTPUT AS #2
3228 PRINT
3230 BODLIN = 0     'INPUT "BODEPLOT(0) OR LINEAR PLOT(1) ";BODLIN
3232 REM IF PAV=1 THEN LPRINT "BODEPLOT(0) OR LINEAR PLOT(1) ";BODLIN
3234 INPUT "HZ(0) OR RADIANS(1) ";HZRAD
3236 IF PAV=1 THEN LPRINT "HZ(0) OR RADIANS(1) ";HZRAD
3262 INPUT "INPUT LOW FREQUENCY END  ";G
3264 IF PAV=1 THEN LPRINT "INPUT LOW FREQUENCY END  ";G
3266 INPUT "INPUT HIGH FREQUENCY END  ";H
3268 IF PAV=1 THEN LPRINT "INPUT HIGH FREQUENCY END ";H
3270 PRINT "INPUT FREQUENCY INCREMENT "
3271 INPUT "OR <RET> FOR 100 POINTS ";D
3272 IF D=0 THEN D=(H-G)/100
3273 IF ((H-G)/D > 105) THEN GOTO 3274 ELSE GOTO 3280
3274 PRINT "INCREMENT MUST BE LARGER THAN (HIGH FREQ. - LOW FREQ.)/100"
3276 PRINT "RE-INPUT INCREMENT"
3278 INPUT D
3279 GOTO 3272
3280 IF PAV=1 THEN LPRINT "INPUT FREQUENCY INCREMENT  ";D:LPRINT
3282 IF G=0 THEN G=D
3290 REM INPUT "DO YOU WANT A TABLE(0), GRAPH(1), OR BOTH(2) ";CHOICE
3291 REM IF PAV=1 THEN LPRINT "DO YOU WANT A TABLE(0), GRAPH(1), OR BOTH(2) ";CHOICE
3300 IF HZRAD =0 THEN FW$="FREQUENCY" ELSE FW$="RADIANS/SEC"
3310 REM IF BODLIN=1 THEN HZRAD$="MAG" ELSE HZRAD$="MAG(DB)"
3340 PRINT
3350 REM IF CHOICE=1 THEN GOTO 3380
3360 IF MONTE =0 THEN PRINT FW$;TAB(18);"MAGNITUDE";TAB(36);"MAGNITUDE(DB)";TAB(54);"PHASE"
3375 REM IF PAV=1 THEN LPRINT TAB(10);FW$;TAB(28);HZRAD$;TAB(48);"PHASE"
3380 IF D<0 THEN F2=-D:GOTO 3420
3400 F2=1+(H-G)/D
3420 IF D<0 THEN D=-((H/G)^(1/(-D-1)))
3440 F1=G
3450 NS=1:IECEP=F2
3460 FOR I1=1 TO F2
3470 IF HZRAD=0 THEN W=2*PI*F1 ELSE W=F1
3480 D1=E:D2=F:GOSUB 5660
3500 V=B1:U=D2
3520 IF (-1)^(E+F) >0 THEN 3560
3540 U=U-180
3560 D1=E:D2=E
3580 GOSUB 5660:V=V/B1:U=U-D2
3590 IF P(1,2)<> 0 THEN R1 = -1/P(1,2)
3595 IF P(0,N) <>0 THEN R2 = -1/P(0,N)
3600 IF U>180 THEN U=U-360
3620 IF U<-180 THEN U=U+360
3630 IF (P(0,N) <> 0) AND (P(1,2)<>0) THEN V = V*(R1+R2)/R2
3640 IF V > 0 THEN DB=LGTEN*LOG(V) ELSE DB = -999
3645 T1=F1
3646 T2=V
3647 T3=DB
3648 T4=U
3650 REM
3660 IF MONTE=0 THEN PRINT CSNG(T1);TAB(18);CSNG(T2);TAB(36);CSNG(T3);TAB(54);CSNG(T4)
3661 IF MONTE <>0 THEN IY=CSRLIN:LOCATE 25,1:PRINT"FREQUENCY = ";CSNG(T1);TAB(55);"MONTE CARLO NUMBER = ";MONTE-MC+1;:LOCATE IY,1
3662 REM IF PAV=1 THEN LPRINT USING "##########.#####";T1;
3680 REM IF BODLIN = 1 THEN PRINT USING "###########.#######";T2;
3682 REM IF (PAV = 1) AND (BODLIN=1) THEN LPRINT USING "###########.#######";T2
3685 REM IF BODLIN=0 THEN PRINT USING "###########.#######";T3;
3687 REM IF (PAV=1) AND (BODLIN=0) THEN LPRINT USING "###########.#######";T3;
3700 REM PRINT USING "      #####.#######";T4
3703 REM IF PAV=1 THEN LPRINT USING "      #####.#######";T4
3705 PRINT #3,CSNG(T1);TAB(18);CSNG(T2);TAB(36);CSNG(T3);TAB(54);CSNG(T4)
3710 C1(I1)=T1:E1(I1)=T4
3712 IF BODLIN=1 THEN D1(I1)=T2 ELSE D1(I1)=T3
3713 IF ORIGFLAG = 0 THEN ORIGD1(I1)=T3   'store initial response
3714 NOWD1(I1)=T3                         'store current response
3715 IF T2 > AMAXLIN THEN AMAXLIN = T2
3716 IF T3> AMAXDB THEN AMAXDB = T3
3720 IF D<0 THEN F1 =-F1*D:GOTO 3760
3740 F1=F1+D
3760 NEXT I1
3765 CLOSE #2
3766 CLOSE #3
3770 IF (ORIGFLAG = 0) AND (P(1,2)<>0) AND (P(N,0)<>0) THEN ORIGFLAG=1:RI=1/P(1,2):RO=1/P(N,0)
3780 IF MC>0 THEN GOSUB 11000
3782 GOSUB 11900
3783 PRINT
3784 IF (F$="") OR (F$="DEFAULT.net") THEN INPUT "NAME OF FILE (*.NET) TO STORE INPUT DATA OR <RET> ";G$
3786 IF (PAV=1) AND ((F$="") OR (F$="DEFAULT.net")) THEN LPRINT"NAME OF FILE (*.NET) TO STORE INPUT DATA OR <RET> ";G$
3788 IF G$<>"" THEN NAME "DEFAULT.NET" AS G$+".NET"
3800 INPUT "ANOTHER PROBLEM  Y/N or B";Z$
3820 REM INPUT Z$
3840 IF (Z$="y") OR (Z$="Y") THEN 10
3845 IF (Z$="b") OR (Z$="B") THEN GOTO 3782
3860 INPUT "RETURN TO MAIN MENU Y/N ";Z$
3870 IF (Z$="Y") OR (Z$="y") THEN CHAIN"RFDESIGN
3880 END
3885 '
3886 ' Calculation Portion
3887 '
3888 '
3900 REM IF I=0 THEN 4000
3920 A(I,I)=A(I,I)+V
3940 REM IF J=0 THEN 4020
3960 A(I,J)=A(I,J)-V
3980 A(J,I)=A(J,I)-V
4000 A(J,J)=A(J,J)+V
4020 IF I<N THEN 4060
4040 N=I
4060 IF J<N THEN 4100
4080 N=J
4100 RETURN
4120 REM IF I=0 THEN 4220
4140 B(I,I)=B(I,I)+V
4160 REM IF J=0 THEN 4020
4180 B(I,J)=B(I,J)-V
4200 B(J,I)=B(J,I)-V
4220 B(J,J)=B(J,J)+V
4240 GOTO 4020
4260 REM IF I=0 THEN 4360
4280 B1(I,I)=B1(I,I)+V
4300 REM IF J=0 THEN 4020
4320 B1(I,J)=B1(I,J)-V
4340 B1(J,I)=B1(J,I)-V
4360 B1(J,J)=B1(J,J)+V
4380 GOTO 4020
4400 IF I<>0 AND K<>0 THEN A(I,K)=A(I,K)+V
4420 IF J<>0 AND L<>0 THEN A(J,L)=A(J,L)+V
4440 IF J<>0 AND K<>0 THEN A(J,K)=A(J,K)-V
4460 IF I<>0 AND L<>0 THEN A(I,L)=A(I,L)-V
4480 IF K<N THEN 4520
4500 N=K
4520 IF L<N THEN 4560
4540 N=L
4560 GOTO 4020
4580 ' determinant computation
4600 IF N>1 THEN 4640
4620 D1=A(N,N):D2=B(N,N):RETURN
4640 D1=1:D2=0:K=1
4660 L=K
4680 S=ABS(A(K,K))+ABS(B(K,K))
4700 FOR I=K TO N
4720 T=ABS(A(I,K))+ABS(B(I,K))
4740 IF S>=T THEN 4780
4760 L=I:S=T
4780 NEXT I
4800 IF L=K THEN 4960
4820 FOR J=1 TO N
4840 S=-A(K,J)
4860 A(K,J)=A(L,J)
4880 A(L,J)=S
4900 S1=-B(K,J)
4920 B(K,J)=B(L,J):B(L,J)=S1
4940 NEXT J
4960 L=K+1
4980 FOR I=L TO N
5000 S1=A(K,K)*A(K,K)+B(K,K)*B(K,K)
5020 S=(A(I,K)*A(K,K)+B(I,K)*B(K,K))/S1
5040 B(I,K)=(A(K,K)*B(I,K)-A(I,K)*B(K,K))/S1
5060 A(I,K)=S:NEXT I
5080 J2=K-1
5100 IF J2=0 THEN 5220
5120 FOR J=L TO N
5140 FOR I=1 TO J2
5160 A(K,J)=A(K,J)-A(K,I)*A(I,J)+B(K,I)*B(I,J)
5180 B(K,J)=B(K,J)-B(K,I)*A(I,J)-A(K,I)*B(I,J)
5200 NEXT I:NEXT J
5220 J2=K:K=K+1
5240 FOR I=K TO N
5260 FOR J=1 TO J2
5280 A(I,K)=A(I,K)-A(I,J)*A(J,K)+B(I,J)*B(J,K)
5300 B(I,K)=B(I,K)-B(I,J)*A(J,K)-A(I,J)*B(J,K)
5320 NEXT J:NEXT I
5340 IF K<>N THEN 4660
5360 L=1
5380 J2=INT(N/2)
5400 IF N=2*J2 THEN 5480
5420 L=0
5440 D1=A(N,N)
5460 D2=B(N,N)
5480 FOR I=1 TO J2
5500 J=N-I+L
5520 S=A(I,I)*A(J,J)-B(I,I)*B(J,J)
5540 S1=A(I,I)*B(J,J)+A(J,J)*B(I,I)
5560 T=D1*S-D2*S1
5580 D2=D2*S+D1*S1
5600 D1=T
5620 NEXT I
5640 RETURN
5660 N1=N:N=N-1:I=0
5680 FOR K=1 TO N
5700 IF K<>D1 THEN 5740
5720 I=1
5740 J=0
5760 FOR L=1 TO N
5780 IF L<>D2 THEN 5820
5800 J=1
5820 A(K,L)=P(K+I,L+J)
5840 B(K,L)=W*Q(K+I,L+J)+Q1(K+I,L+J)/W
5860 NEXT L:NEXT K
5880 GOSUB 4600
5900 N=N1
5920 IF ABS(D1)>ABS(D2) THEN MAX=ABS(D1) ELSE MAX=ABS(D2)
5922 IF MAX <>0 THEN B1=MAX*SQR((D1/MAX)^2       +(D2/MAX)^2       )
5923 IF MAX = 0 THEN B1=SQR((D1)*(D1)+(D2)*(D2))
5940 IF D1<>0 THEN 6020
5960 IF D2=0 THEN 6100
5980 IF D2>0 THEN D2=90:GOTO 6100
6000 D2=-90:GOTO 6100
6020 IF D1<0 THEN Q=180:GOTO 6060
6040 Q=0
6060 IF D2<0 THEN Q=-Q
6080 D2=Q+180*ATN(D2/D1)/PI
6100 RETURN
6200 '
6201 '
6202 '
6205 '******************** Print help information *****************
6206 '
6220 PRINT"Data must be given in the following format:"
6240 PRINT
6260 PRINT"R    (resistor)"
6280 PRINT"from node #, to node #, value in ohms"
6300 PRINT"C    (capacitor)"
6320 PRINT"from node #, to node #, value in farads"
6340 PRINT"L    (inductor)"
6360 PRINT"from node #, to node #, value in henries"
6380 PRINT"F    (fet transistor)"
6400 PRINT"gate, source, drain, gain (amps/volts)"
6420 PRINT"B    (bipolar transistor)"
6440 PRINT"base, emitter, collector, beta, b-e ohms"
6460 PRINT"O    (op-amp)"
6480 PRINT"+in, -in, +out, -out, gain, ohms out"
6540 PRINT
6560 PRINT "Node 1 is always the input."
6570 PRINT "The highest node is always the output."
6580 PRINT "Node 0 is always ground."
6585 INPUT "Press <RET> to continue. ";T$
6587 CLS
6590 RETURN
11000 REM
11010 MC = MC-1
11015 IF (F$="") THEN F$=G$:G$=""
11020 OPEN "TEMPF" FOR OUTPUT AS #3
11030 PRINT #3,PAV,MC,BODLIN,HZRAD,G,H,D,MONTE,RT,CT,LT
11032 PRINT #3, F$
11034 PRINT #3, HZRAD$
11036 PRINT #3, FW$
11037 PRINT #3, AMAXLIN
11038 PRINT #3, AMAXDB
11040 CLOSE #3
11045 CLEAR
11048 DEFDBL A-H,M-Z
11050 OPEN "TEMPF" FOR INPUT AS #3
11060 INPUT #3,PAV,MC,BODLIN,HZRAD,G,H,D,MONTE,RT,CT,LT
11062 INPUT #3, F$
11064 INPUT #3, HZRAD$
11066 INPUT #3, FW$
11067 INPUT #3, AMAXLIN
11068 INPUT #3, AMAXDB
11070 CLOSE #3
11075 ON ERROR GOTO 25000
11076 RANDOMIZE TIMER
11080 GOTO   1140
11900 Q$="MONITOR":GOSUB 26000:Q$=""        'GET MONITOR PARAMETER
12000 CLS                       'DISPLAY SUBROUTINE FOR EXACT ANALYSIS
12005 IF MONTE >0 THEN DAT$="DATA.1"
12006 MC=0
12010 PRINT "(0) CONTINUE"
12020 PRINT "(1) DISPLAY TABLE"
12030 PRINT "(2) PRINT AND DISPLAY TABLE"
12070 PRINT "(3) DISPLAY MAGNITUDE RESPONSE"
12080 PRINT "(4) DISPLAY LOG MAGNITUDE RESPONSE"
12083 PRINT "(5) DISPLAY PHASE RESPONSE"
12086 PRINT "(6) MONITOR SELECTION"
12087 IF (NOP=0) AND (F$<>"") AND (MONTE=0) THEN PRINT "(7) REPEAT WITH CHANGE IN COMPONENT VALUE"
12088 IF (NOP=0) AND (F$<>"") AND (MONTE=0) THEN PRINT "(8) SHOW COMPONENT VALUES "
12089 IF (NOP = 0) AND (F$<>"") AND (MONTE=0) THEN PRINT "(9) SAVE COMPONENT VALUES "
12090 IF (NOP = 0) AND (F$<>"") AND (MONTE=0) THEN PRINT "(10) REPEAT WITH CHANGE AND SHOW MEAN SQUARE ERROR"
12100 INPUT CHO
12110 IF CHO = 0 THEN RETURN
12120 IF CHO = 1 THEN GOSUB 13000
12130 IF CHO = 2 THEN PR=1:GOSUB 13000
12140 IF CHO = 3 THEN IBLOT = 1:GOSUB 20000
12150 IF CHO = 4 THEN IBLOT = 0:GOSUB 20000
12160  IF CHO = 5 THEN GOSUB 20570:GOSUB 20700
12170 IF CHO=6 THEN GOSUB 24000
12180 IF CHO = 7 THEN GOSUB 31000:GOSUB 30800
12182 IF CHO = 8 THEN GOSUB 31000
12184 IF CHO = 9 THEN GOSUB 31200
12187 IF CHO = 10 THEN GOSUB 31000:GOSUB 32400:GOSUB 30800
12900 GOTO 12000
13000 OPEN DAT$ FOR INPUT AS #1
13005 I=0
13010 CLS
13015 IF MONTE > 0 THEN LOCATE 25,40:PRINT "MONTE CARLO RUN # ";MC+1;
13020 LOCATE 1,1:PRINT "FREQUENCY";TAB(18);"MAGNITUDE";TAB(36);"MAGNITUDE(DB)";TAB(54);"PHASE"
13021 IF PR=1 THEN LPRINT:LPRINT:LPRINT
13023 IF (PR=1) AND (MONTE >0) THEN LPRINT "MONTE CARLO RUN # ";MC+1
13025 IF PR=1 THEN LPRINT "FREQUENCY";TAB(18);"MAGNITUDE";TAB(36);"MAGNITUDE(DB)";TAB(54);"PHASE"
13030 IF EOF(1) THEN GOTO 13060 ELSE GOTO 13040
13040 INPUT #1,A,B,C,D4
13045 IF PR=1 THEN LPRINT CSNG(A);TAB(18);CSNG(B);TAB(36);CSNG(C);TAB(54);CSNG(D4)
13050 PRINT CSNG(A);TAB(18);CSNG(B);TAB(36);CSNG(C);TAB(54);CSNG(D4)
13051 I=I+1
13052 IF EOF(1) THEN GOTO 13060
13053 IF (I= 21) AND (PR=0) THEN LOCATE 25,1:INPUT "PRESS <RET> TO CONTINUE";C$:GOTO 13005
13055 GOTO 13030
13060 CLOSE #1
13065 IF (MC>=MONTE) OR (PR=0) THEN LOCATE 25,1:INPUT "PRESS <RET> TO CONTINUE";C$
13070 IF (MC >= MONTE) THEN PR=0:MC=0:RETURN 12000
13080 MC=MC+1
13090 E$=STR$(MC+1):DAT$="DATA."+MID$(E$,2)
13100 GOTO 13000
20000 REM INPUT "PRESS <RET> TO PLOT";E$
20010 CLS
20020 REM DEFINT X,Y,C
20030  KEY OFF
20040 IF NUM <=1 THEN SCREEN 2:WIDTH 80:PIX=200:IC1=1:IC2=1
20050 IF NUM = 2 THEN SCREEN 8:WIDTH 80:PIX=200:COLOR 10:IC1=14:IC2=12
20060 IF NUM = 3 THEN SCREEN 10:WIDTH 80:PIX=350:IC1=1:IC2=1
20070 IF NUM = 4 THEN SCREEN 9:WIDTH 80:PIX=350:COLOR 10:IC1=14:IC2=12
20080 LOCATE 1,35:IF IBLOT = 0 THEN PRINT "MAGNITUDE PLOT IN DB" ELSE PRINT "MAGNITUDE PLOT IN VOLTS"
20090 IF IBLOT = 0 THEN GOSUB 20460 ELSE GOSUB 20570
20100 LOCATE 2,4:PRINT CSNG(DB1); FR$ :LOCATE 7,4:PRINT CSNG(DB2); FR$ :
20110 LOCATE 12,4:PRINT CSNG(DB3); FR$ :LOCATE 17,4:PRINT CSNG(DB4); FR$
20120 LOCATE 22,4:PRINT CSNG(DB5); FR$
20130 LOCATE 24,11:PRINT USING "##.###^^^^";FL1;:LOCATE 24,22:PRINT USING "##.###^^^^";FL1+(FH-FL1)/5;:LOCATE 24,33:PRINT USING "##.###^^^^";FL1+2*(FH-FL1)/5;
20140 LOCATE 24,44:PRINT USING "##.###^^^^";FL1+(FH-FL1)*3/5;:LOCATE 24,55:PRINT USING "##.###^^^^";FL1+(FH-FL1)*4/5;:LOCATE 24,66:PRINT USING "##.###^^^^";FH;
20150 REM IF IWISH=0 THEN PRINT " (HZ)"; ELSE PRINT " RAD"  ;
20160  REM IC=0:LINE -(0,0),IC
20170  FOR I=1 TO 22
20180   READ IX,IY,IP
20190     IX=IX*640/360   'X IS 0 TO 360  Y IS 0TO 240
20200  IY=IY*PIX/240
20210     IY=PIX-IY 'do y transformation to get picture right side up.
20220   IF IP=13 THEN IC=0 ELSE IC=IC1
20230     LINE -(IX,IY),IC
20235 IIX=IX:IIY=IY
20240 NEXT I
20250 FOR ITR= NS TO IECEP
20260 IF IBLOT =0 THEN IY=2.5*D1(ITR)+230-2.5*UPPER ELSE IY=30+200*D1(ITR)/AMAX
20270 IF IY<30 THEN IY=30
20280 IX=5 *(ITR-NS)*50/(IECEP-NS)+60:IX=IX*640/360
20290                 IY=IY*PIX/240:IY=PIX-IY
20300 IF ITR<>NS THEN IC=IC2 ELSE IC=IC1
20310  LINE -(IX,IY),IC
20320 NEXT ITR
20322 IF (MC>=MONTE) THEN GOTO 20330
20324 MC=MC+1:E$=STR$(MC+1):DAT$="DATA."+MID$(E$,2)
20325 UPPER1=UPPER:AMAX1=AMAX
20326 IF IBLOT =0 THEN GOSUB 20460 ELSE GOSUB 20570
20327 UPPER=UPPER1:AMAX=AMAX1
20328 PSET (IIX,IIY):GOTO 20250
20330 LOCATE 1,1:INPUT "PRESS <RET> TO CONTINUE";FWE$
20340 SCREEN 0
20350 RESTORE
20360 MC=0:RETURN
20370  DATA                        60,30 ,13
20380  DATA   60,230,12,110,30 ,13,110,230,12
20390  DATA  160,30,13,160,230,12,210,30,13
20400  DATA  210,230,12,260,30,13,260,230,12
20410 DATA 310,30,13,310,230,12
20420  DATA  60,230,12, 60,180,12,310,180,12
20430  DATA  310,130,12,60,130,12, 60, 80,12
20440  DATA 310, 80,12,310, 30,12,60, 30,12
20450  DATA  60,130,12
20460 REM
20465 I = 0
20470 UPPER= -210
20480 AMAX=-210
20482 OPEN DAT$ FOR INPUT AS #1
20484 IF EOF(1) THEN GOTO 20520  ELSE GOTO 20490
20490 I = I + 1
20492 INPUT #1, C1(I),DUMMY,D1(I),E1(I)
20496 REM
20500 IF D1(I)> AMAX THEN AMAX = D1(I)
20510 GOTO 20484
20520 AMAX = AMAXDB:IF UPPER< AMAX  THEN UPPER=UPPER + 20
20525 NS=1:IECEP=I
20530 IF UPPER < AMAX  THEN GOTO 20520
20540 DB1=UPPER:DB2=UPPER-20:DB3=UPPER-40:DB4=UPPER-60:DB5=UPPER-80
20550 FR$="DB"
20555 CLOSE #1
20556 FL1=C1(1):FH=C1(IECEP)
20560 RETURN
20570 REM
20580 AMAX=0:I=0
20582 OPEN DAT$ FOR INPUT AS #1
20584 IF EOF(1) THEN GOTO 20620
20586 I = I + 1
20588 INPUT #1, C1(I),D1(I),DUMMY,E1(I)
20590 REM
20600 REM IF D1(I)> AMAX THEN AMAX = D1(I)
20610 GOTO 20584
20620 AMAX=AMAXLIN:Q=1E-30
20630 IF AMAX > Q THEN Q=Q*2
20640 IF AMAX > Q THEN Q=Q*2.5
20650 IF AMAX > Q THEN Q=Q*2:GOTO 20630
20660 AMAX=Q
20670 DB1=AMAX :DB2=AMAX*.75:DB3=AMAX*.5 :DB4=AMAX*.25:DB5=0
20680 FR$="  "
20682 NS=1:IECEP=I:FL1=C1(1):FH=C1(IECEP)
20684 CLOSE #1
20690 RETURN
20700 REM INPUT "PRESS <RET> TO PLOT";E$
20710 CLS
20720 IF NUM <=1 THEN SCREEN 2:WIDTH 80:PIX=200:IC1=1:IC2=1
20730 IF NUM = 2 THEN SCREEN 8:WIDTH 80:PIX=200:COLOR 10:IC1=14:IC2=12
20740 IF NUM = 3 THEN SCREEN 10:WIDTH 80:PIX=350:IC1=1:IC2=1
20750 IF NUM = 4 THEN SCREEN 9:WIDTH 80:PIX=350:COLOR 10:IC1=14:IC2=12
20760 LOCATE 1,35:PRINT "PHASE PLOT IN DEGREES"
20770 LOCATE 2,4:PRINT      "180":LOCATE 7,4:PRINT     "90" :
20780 LOCATE 12,4:PRINT     "0"  :LOCATE 17,4:PRINT     "-90"
20790 LOCATE 22,4:PRINT     "-180"
20800 LOCATE 24,11:PRINT USING "##.###^^^^";FL1;:LOCATE 24,22:PRINT USING "##.###^^^^";FL1+(FH-FL1)/5;:LOCATE 24,33:PRINT USING "##.###^^^^";FL1+2*(FH-FL1)/5;
20810 LOCATE 24,44:PRINT USING "##.###^^^^";FL1+(FH-FL1)*3/5;:LOCATE 24,55:PRINT USING "##.###^^^^";FL1+(FH-FL1)*4/5;:LOCATE 24,66:PRINT USING "##.###^^^^";FH;
20820 REM IF IWISH=0 THEN PRINT " (HZ)"; ELSE PRINT " RAD"  ;
20830  REM IC=0:LINE -(0,0),IC
20840  FOR I=1 TO 22
20850   READ IX,IY,IP
20860     IX=IX*640/360   'X IS 0 TO 360  Y IS 0TO 240
20870  IY=IY*PIX/240
20880     IY=PIX-IY 'do y transformation to get picture right side up.
20890   IF IP=13 THEN IC=0 ELSE IC=IC1
20900     LINE -(IX,IY),IC
20905 IIX=IX:IIY=IY
20910 NEXT I
20920 FOR ITR= NS TO IECEP
20930 IY= .555555555#*E1(ITR)+130
20940 IF IY<30 THEN IY=30
20950 IX=5 *(ITR-NS)*50/(IECEP-NS)+60:IX=IX*640/360
20960                 IY=IY*PIX/240:IY=PIX-IY
20970 IF ITR<>NS THEN IC=IC2 ELSE IC=IC1
20980                                 LINE -(IX,IY),IC
20990 NEXT ITR
20992 IF (MC>=MONTE) THEN GOTO 21000
20994 MC=MC+1:E$=STR$(MC+1):DAT$="DATA."+MID$(E$,2)
20996 GOSUB 20460
20998 PSET (IIX,IIY):GOTO 20920
21000 LOCATE 1,1:INPUT "PRESS <RET> TO CONTINUE";FWE$
21010 SCREEN 0
21020 RESTORE
21030 RETURN
21040  DATA                        60,30 ,13
21050  DATA   60,230,12,110,30 ,13,110,230,12
21060  DATA  160,30,13,160,230,12,210,30,13
21070  DATA  210,230,12,260,30,13,260,230,12
21080 DATA 310,30,13,310,230,12
21090  DATA  60,230,12, 60,180,12,310,180,12
21100  DATA  310,130,12,60,130,12, 60, 80,12
21110  DATA 310, 80,12,310, 30,12,60, 30,12
21120  DATA  60,130,12
24000 CLS
24010 PRINT
24020 LOCATE 6,6:PRINT "        SELECT MONITOR TYPE "
24030 LOCATE 8,6:PRINT " (0) MONOCHROME ADAPTOR AND DISPLAY "
24040 LOCATE 10,6:PRINT " (1) CGA ADAPTOR AND MONOCHROME DISPLAY "
24050 LOCATE 12,6:PRINT " (2) CGA ADAPTOR AND COLOR DISPLAY "
24060 LOCATE 14,6:PRINT " (3) EGA ADAPTOR AND MONOCHROME DISPLAY "
24070 LOCATE 16,6:PRINT " (4) EGA ADAPTOR AND COLOR DISPLAY "
24080 LOCATE 22,6:INPUT NUM
24090 OPEN "MONITOR" FOR OUTPUT AS #1
24100 PRINT #1, NUM
24110 CLOSE #1
24120 RETURN 12000
25000 A4=ERR:A5=ERL
25010 IF (A4=58) THEN INPUT "FILE ALREADY EXISTS, PRESS <RET> TO CONTINUE ";CD$:RESUME 3784
25020 CLS
25030 IF (A4 = 5) AND ( CHO<>0) THEN SCREEN 0:PRINT : PRINT "ILLEGAL MONITOR SELECTION, PRESS <RET> TO CONTINUE":PRINT:INPUT C$:RESUME 12000
25035 IF (A4=53) AND (Q$="MONITOR") THEN OPEN "MONITOR" FOR OUTPUT AS #1:PRINT #1,NUM:CLOSE #1:RESUME NEXT
25040 PRINT : PRINT "ERROR CODE ";A4 ;" IN LINE "; A5:PRINT" PRESS <RET> TO CONTINUE":PRINT:INPUT C$:RESUME 10
26000 Q$="MONITOR"
26010 OPEN "MONITOR" FOR INPUT AS #1
26020 INPUT #1, NUM
26030 CLOSE #1
26040 RETURN
30000 IF (NOP = 1) OR (F$="") OR (MONTE<>0) THEN RETURN
30005  C2$="":INPUT "MODIFY ANY VALUES y/N ";C2$
30010  IF (C2$="Y") OR (C2$="y") THEN GOTO 30020 ELSE RETURN
30020  C2$=""
30030 INPUT "ENTER COMPONENT TYPE (R,L,OR C) ";Z$:Z$=LEFT$(Z$,1)
30040 IF PAV=1 THEN LPRINT "ENTER COMPONENT TYPE ";Z$
30050  PRINT "ENTER NODES, VALUES "
30060  IF PAV = 1 THEN LPRINT "ENTER NODES, VALUES "
30070 IF Z$="R" OR Z$="r" THEN GOSUB 30200
30080 IF Z$="C" OR Z$="c" THEN GOSUB 30400
30090 IF Z$="L" OR Z$="l" THEN GOSUB 30600
30100 INPUT "MODIFY ANY MORE VALUES y/N ";C2$
30105 AMAXLIN = -1E+30
30106 AMAXDB = -1E+30
30110 GOTO 30010
30200  INPUT I,J,V
30210 UPPERB = V*(1+RT/100):LOWERB = V*(1-RT/100)
30220 V = ((UPPERB - LOWERB )*RND + LOWERB)
30230 IF (PAV=1) AND (MONTE=0) THEN LPRINT CSNG(I);",";CSNG(J);",";CSNG(V)
30231 V = 1/V
30236 V=V+A(I,J)
30240 GOSUB 3900:RETURN
30400  INPUT I,J,V
30410 UPPERB = V*(1+CT/100):LOWERB = V*(1-CT/100)
30420 V = ((UPPERB - LOWERB )*RND + LOWERB)
30430 IF (PAV=1) AND (MONTE=0) THEN LPRINT CSNG(I);",";CSNG(J);",";CSNG(V)
30446 V=V+B(I,J)
30450 GOSUB 4120:RETURN
30600  INPUT I,J,V
30610 UPPERB = V*(1+LT/100):LOWERB = V*(1-LT/100)
30620 V = ((UPPERB - LOWERB )*RND + LOWERB)
30630 IF (PAV=1) AND (MONTE=0) THEN LPRINT CSNG(I);",";CSNG(J);",";CSNG(V)
30640 V=-1/V
30646 V=V+B1(I,J)
30650 GOSUB 4260:RETURN
30800  FOR I = 1 TO N
30810 FOR J = 1 TO N
30820 A(I,J) = P(I,J)
30830 B1(I,J)=Q1(I,J)
30840 B(I,J)=Q(I,J)
30845 NEXT J
30846 NEXT I
30850 GOSUB 30030              'ENTER CHANGED VALUE
30855 OPEN "DATA" FOR OUTPUT AS #3
30860 RETURN 2300
31000 REM Routine to show updated component values
31005 CLS:ICOUNT=0
31006 PRINT "CURRENT COMPONENT VALUES  PREVIOUS COMPONENT VALUES"
31010 FOR I = 0 TO N
31020 FOR J = I+1 TO N
31030 IF P(I,J) <>0 THEN PRINT "R(";I;",";J;")=";CSNG(1/ABS(P(I,J)));:ICOUNT=ICOUNT+1
31031 IF P(I,J) <> 0 THEN PRINT TAB(28);PREV$(ICOUNT)
31032 IF P(I,J)<>0 THEN PREV$(ICOUNT)="R("+STR$(I)+","+STR$(J)+")="+STR$(CSNG(1/ABS(P(I,J))))
31034 IF Q(I,J) <>0 THEN PRINT "C(";I;",";J;")=";CSNG(ABS(Q(I,J)));:ICOUNT=ICOUNT+1
31035 IF Q(I,J) <> 0 THEN PRINT TAB(28);PREV$(ICOUNT)
31036 IF Q(I,J) <>0 THEN PREV$(ICOUNT)="C("+STR$(I)+","+STR$(J)+")="+STR$(CSNG(ABS(Q(I,J))))
31038 IF Q1(I,J) <>0 THEN PRINT "L(";I;",";J;")=";CSNG(1/ABS(Q1(I,J)));:ICOUNT=ICOUNT+1
31039 IF Q1(I,J)<> 0 THEN PRINT TAB(28);PREV$(ICOUNT)
31040 IF Q1(I,J) <>0 THEN PREV$(ICOUNT)="L("+STR$(I)+","+STR$(J)+")="+STR$(CSNG(1/ABS(Q1(I,J))))
31042 IF ICOUNT >= 23 THEN GOSUB 32000
31044 NEXT J
31046 NEXT I
31051 X = CSRLIN
31052 LOCATE 1,54:PRINT "ORIGINAL COMPONENT VALUES":Y=CSRLIN
31053 COUNT = 0
31054 COUNT = COUNT + 1
31055 IF ORIG$(COUNT)<>"" THEN LOCATE Y,54:PRINT ORIG$(COUNT):Y=CSRLIN:GOTO 31054
31058 LOCATE 25,1:PRINT "PRESS <RET> TO CONTINUE";
31059 A$=INKEY$:IF A$="" THEN GOTO 31059
31060 LOCATE 25,1:PRINT "                          ";
31065 LOCATE X,1
31070 RETURN
31200 REM Routine to save updated component values
31205 CLS
31210 INPUT "TYPE FILENAME TO SAVE NEW COMPONENTS (NO EXTENSION)";CD$
31215 IF CD$="" THEN RETURN
31220 J = 0
31221 FOR I = 1 TO LEN(CD$)
31222 IF MID$(CD$,I,1)="." THEN J=I
31223 NEXT I
31224 IF J<>0 THEN CD$=MID$(CD$,1,J-1)
31225 CD$=CD$+".NET"
31230 OPEN CD$ FOR OUTPUT AS #2
31240 INPUT "TYPE TITLE";TITLE$
31250 PRINT #2,"; " + TITLE$
31260 FOR I = 0 TO N
31270 FOR J = I+1 TO N
31280 IF P(I,J) <>0 THEN PRINT #2,"R":PRINT #2,I,J,(1/ABS(P(I,J)))
31290 IF Q(I,J) <>0 THEN PRINT #2,"C":PRINT #2,I,J,(ABS(Q(I,J)))
31300 IF Q1(I,J) <>0 THEN PRINT #2,"L":PRINT #2,I,J,(1/ABS(Q1(I,J)))
31310 NEXT J
31320 NEXT I
31330 LOCATE 25,1:PRINT "PRESS <RET> TO CONTINUE";
31340 A$=INKEY$:IF A$="" THEN GOTO 31340
31345 CLOSE #2
31350 RETURN
32000 X = CSRLIN
32010 COUNT = 0
32020 LOCATE 25,1:PRINT "PRESS <RET> TO CONTINUE ";
32030 A$=INKEY$:IF A$="" THEN GOTO 32030
32040 LOCATE X,1
32050 RETURN
32200 REM SUBROUTINE TO GET ORIGINAL COMPONENT VALUES
32205 ICOUNT = 1:COUNT = 1
32210 FOR I = 0 TO N
32220 FOR J = I+1 TO N
32240 IF A(I,J) <>0 THEN ORIG$(ICOUNT)="R("+STR$(I)+","+STR$(J)+")="+STR$(CSNG(1/ABS(A(I,J)))):COUNT=COUNT+1:ICOUNT=ICOUNT+1
32250 IF B(I,J) <>0 THEN ORIG$(ICOUNT)="C("+STR$(I)+","+STR$(J)+")="+STR$(CSNG(ABS(B(I,J))))  :COUNT=COUNT+1:ICOUNT=ICOUNT+1
32260 IF B1(I,J) <>0 THEN ORIG$(ICOUNT)="L("+STR$(I)+","+STR$(J)+")="+STR$(CSNG(1/ABS(B1(I,J)))):COUNT=COUNT+1:ICOUNT=ICOUNT+1
32280 NEXT J
32290 NEXT I
32300 RETURN
32400 REM  Routine to compute mean square error
32402 PRINT "Previous Mean Square Error was ";TEMP
32405 TEMP = 0
32411 OFFSET = 20/2.302*(LOG(P(1,2)/(P(1,2)+P(N,0))))-20/2.302*(LOG(RO/(RO+RI)))
32412 TEST1=P(1,2):TEST2=P(N,0):TEST3=D1(5):TEST4=ORIGD1(5)
32415 FOR I = NS TO IECEP
32420 TEMP=(NOWD1(I)-ORIGD1(I)-OFFSET)^2+TEMP
32430 NEXT I
32440 TEMP = SQR(TEMP)
32450 PRINT "Current Mean Square Error is ";TEMP
32460 RETURN
